import glob
import sys
import logging

class StepFileGenerator(object):
    def __init__(self, basedir):
        self.basedir = basedir

    def read_file(self, name):
        logging.info ("StepFile: using %s" % name)
        #print >> sys.stderr, 'using', name
        fp = open(name, 'r')
        return fp.read()

    def generate_step_file(self, params):
        step_file_contents = ''
        generator_data_dir = '%s/generator_data/%s/' % (self.basedir, params['series'])
        step_files = glob.glob('%s/*.steps' % generator_data_dir)
        step_files.sort()
        for f in step_files:
            filename = f[len(generator_data_dir):-6]
            filename_parts = filename.split('-')
            if len(filename_parts) not in range(2,5):
                raise Exception('Invalid step file name: %s.')
            # Raises exception if first part is not a number
            step_num = int(filename_parts[0])
            if len(filename_parts) == 2:
                step_file_contents += self.read_file(f)
            if len(filename_parts) == 3:
                if filename_parts[2] in [params['task'], params['partitioning']]:
                    step_file_contents += self.read_file(f)
            if len(filename_parts) == 4:
                if filename_parts[2] == params['task'] and filename_parts[3] == params['partitioning']:
                    step_file_contents += self.read_file(f)
                    
        fp = open('%s/%s' % (self.basedir, params['steps']), 'w')
        fp.write(step_file_contents)
        fp.close()
